Program Proba;
{Ertekel a PROBA feladathoz}
Uses TestLib;
{Importlt elemek:
TCase:Integer;           a tesztesetek szma
Function DoTest:Boolean; a teszteset rtkelhet, van output fjl
Procedure Done;          az rtkels vgnek jelzse
Procedure Grade(rf, v:Integer); az rf rszfeladat rtklse, v=0/1
                                ha nem hvjuk, 0 rtket kap a teszeset
Procedure WriteMSG(rf:Integer; M:String); az rf rszfeladat rtkelsnekmagyarzata
            ha nem hvjuk, resen marad
TInF:Text;  teszt input, megnyitva
ToutF:Text; teszt output, megnyitva
CoutF:Text; a versenyz output llomnya, megnyitva
}
Var
  t:Integer;

Procedure Eval;
Const
  MaxN=10000;
  MaxV=200;
Var
  N,V:Longint;
  C:Array[1..MaxN] of record x,y: 0..MaxN+MaxV End;
  H:Array[0..MaxN] of 0..MaxV;
  Hany,Veg:Array[0..MaxV] Of Word;

  Ures,i,j,k:Longint;
  a,x,y,z:Integer;
  M, VM:Longint;
  OK1:Boolean;
Begin{Eval}
  OK1:=True;
  ReadLn(TinF, N,V);
  For i:=1 To V Do Hany[i]:=0;
  For i:=1 To N Do Begin
    Read(TinF, H[i]);
    Inc(Hany[H[i]]);
  End;

  Veg[0]:=0;
  Veg[1]:=Hany[1];
  For i:=2 To V Do Begin
    Veg[i]:=Veg[i-1]+Hany[i];
  End;

  ReadLn(ToutF, M);

  {$I-}
    ReadLn(CoutF, VM);
  {$I+}
   If IOResult<>0 Then Begin
     WriteMSG(1,'HIBA: Output formatum hiba');
    exit
   End;
  If (M<>VM)  Then Begin
     WriteMSG(1,'HIBA:  A helyes eredmeny: '+IntToStr(M)+' es nem '+IntToStr(VM));
     Exit;
  End;

  Grade(1,1);
  WriteMSG(1,'HELYES');

  Ures:=0;
  For k:=1 To M Do Begin
  {$I-}
    ReadLn(CoutF, i,j);
  {$I+}
   If (IOResult<>0) Then Begin
     WriteMSG(2,'HIBA: Output formatum hiba');
     Exit;
   End;
   If  (i<0)Or(i>N) Or(j<0) Or (j>N) Then Begin
     WriteMSG(2,'HIBA: Illegalis lepes: '+InttoStr(i)+' -> '+InttoStr(j));
     Exit;
   End;
   If (j<>Ures)Or(i=j) Then Begin
     WriteMSG(2,'HIBA: Illegalis lepes: '+InttoStr(i)+' -> '+InttoStr(j));
     Exit;
   End;
   H[j]:=H[i];
   Ures:=i;
 End{for k};

 For i:=1 To N Do
   If (i<Veg[H[i]-1]+1)Or(i>Veg[H[i]])  Then Begin
     WriteMSG(2,'HIBA: Nem lett rendezett a sor!');
     Exit;
   End;

 Grade(2,1);
 WriteMSG(2,'HELYES');

End{Eval};

Begin{Prog}
  For t:=1 To TCase Do Begin
    If DoTest Then
      Eval;
  End;
  Done;
End.
